#ifndef __COMMON_CONTROLS_H
#define __COMMON_CONTROLS_H

*--	#define	UNICODE
#define WM_USER             0x0400
#define _WIN32              0x0400
#define WINVER              0x0400
#define UNICODE				.F.

*
* Window field offsets for GetWindowLong()
*

#define GWL_WNDPROC         (-4)
#define GWL_HINSTANCE       (-6)
#define GWL_HWNDPARENT      (-8)
#define GWL_ID              (-12)
#define GWL_STYLE           (-16)
#define GWL_EXSTYLE         (-20)
#define GWL_USERDATA        (-21)


*
* Class field offsets for GetClassLong()
*

#define GCL_MENUNAME        (-8)
#define GCL_HBRBACKGROUND   (-10)
#define GCL_HCURSOR         (-12)
#define GCL_HICON           (-14)
#define GCL_HMODULE         (-16)
#define GCL_CBWNDEXTRA      (-18)
#define GCL_CBCLSEXTRA      (-20)
#define GCL_WNDPROC         (-24)
#define GCL_STYLE           (-26)
#define GCW_ATOM            (-32)

#define CW_USEDEFAULT       (-1)	&&((int)0x80000000)

#define ICC_LISTVIEW_CLASSES 0x00000001 &&	// listview, header
#define ICC_TREEVIEW_CLASSES 0x00000002 &&	// treeview, tooltips
#define ICC_BAR_CLASSES      0x00000004 &&	// toolbar, statusbar, trackbar, tooltips
#define ICC_TAB_CLASSES      0x00000008 &&	// tab, tooltips
#define ICC_UPDOWN_CLASS     0x00000010 &&	// updown
#define ICC_PROGRESS_CLASS   0x00000020 &&	// progress
#define ICC_HOTKEY_CLASS     0x00000040 &&	// hotkey
#define ICC_ANIMATE_CLASS    0x00000080 &&	// animate
#define ICC_WIN95_CLASSES    0x000000FF
#define ICC_DATE_CLASSES     0x00000100 &&	// month picker, date picker, time picker, updown
#define ICC_USEREX_CLASSES   0x00000200 &&	// comboex
#define ICC_COOL_CLASSES     0x00000400 &&	// rebar (coolbar) control
*--	#if (_WIN32_IE >= 0x0400)
#define ICC_INTERNET_CLASSES 0x00000800
#define ICC_PAGESCROLLER_CLASS 0x00001000   &&	// page scroller
#define ICC_NATIVEFNTCTL_CLASS 0x00002000   &&	// native font control
*--	#endif


*-- LoadLibraryEx parameters

#define DONT_RESOLVE_DLL_REFERENCES     0x00000001
#define LOAD_LIBRARY_AS_DATAFILE        0x00000002
#define LOAD_WITH_ALTERED_SEARCH_PATH   0x00000008

*--	//====== COMMON CONTROL STYLES ================================================

#define CCS_TOP                 0x00000001
#define CCS_NOMOVEY             0x00000002
#define CCS_BOTTOM              0x00000003
#define CCS_NORESIZE            0x00000004
#define CCS_NOPARENTALIGN       0x00000008
#define CCS_ADJUSTABLE          0x00000020
#define CCS_NODIVIDER           0x00000040
*--	#if (_WIN32_IE >= 0x0300)
#define CCS_VERT                0x00000080
#define CCS_LEFT                (BitOr( CCS_VERT, CCS_TOP))
#define CCS_RIGHT               (BitOr( CCS_VERT, CCS_BOTTOM))
#define CCS_NOMOVEX             (BitOr( CCS_VERT, CCS_NOMOVEY))
*--	#endif

#define IMAGE_BITMAP		0
#define IMAGE_ICON		1
#define IMAGE_CURSOR		2
*--	#if(WINVER >= 0x0400)
#define IMAGE_ENHMETAFILE	3

#define LR_DEFAULTCOLOR		0x0000
#define LR_MONOCHROME		0x0001
#define LR_COLOR		0x0002
#define LR_COPYRETURNORG	0x0004
#define LR_COPYDELETEORG	0x0008
#define LR_LOADFROMFILE		0x0010
#define LR_LOADTRANSPARENT	0x0020
#define LR_DEFAULTSIZE		0x0040
#define LR_VGACOLOR		0x0080
#define LR_LOADMAP3DCOLORS	0x1000
#define LR_CREATEDIBSECTION	0x2000
#define LR_COPYFROMRESOURCE	0x4000
#define LR_SHARED		0x8000

*--	//====== Ranges for control message IDs =======================================

#define LVM_FIRST               0x1000      &&	// ListView messages
#define TV_FIRST                0x1100      &&	// TreeView messages
#define HDM_FIRST               0x1200      &&	// Header messages
#define TCM_FIRST               0x1300      &&	// Tab control messages

*--	#if (_WIN32_IE >= 0x0400)
#define PGM_FIRST               0x1400      &&	// Pager control messages
#define CCM_FIRST               0x2000      &&	// Common control shared messages


#define CCM_SETBKCOLOR          (CCM_FIRST + 1) &&	// lParam is bkColor

#define CCM_SETCOLORSCHEME      (CCM_FIRST + 2) &&	// lParam is color scheme
#define CCM_GETCOLORSCHEME      (CCM_FIRST + 3) &&	// fills in COLORSCHEME pointed to by lParam
#define CCM_GETDROPTARGET       (CCM_FIRST + 4)
#define CCM_SETUNICODEFORMAT    (CCM_FIRST + 5)
#define CCM_GETUNICODEFORMAT    (CCM_FIRST + 6)

*--	#endif

*--	#if (_WIN32_IE >= 0x0400)
*--	// for tooltips
#define INFOTIPSIZE		1024
*--	#endif


*--	/* Stock Logical Objects */

#define WHITE_BRUSH         0
#define LTGRAY_BRUSH        1
#define GRAY_BRUSH          2
#define DKGRAY_BRUSH        3
#define BLACK_BRUSH         4
#define NULL_BRUSH          5
#define HOLLOW_BRUSH        NULL_BRUSH
#define WHITE_PEN           6
#define BLACK_PEN           7
#define NULL_PEN            8
#define OEM_FIXED_FONT      10
#define ANSI_FIXED_FONT     11
#define ANSI_VAR_FONT       12
#define SYSTEM_FONT         13
#define DEVICE_DEFAULT_FONT 14
#define DEFAULT_PALETTE     15
#define SYSTEM_FIXED_FONT   16

*	/* Background Modes */
#define TRANSPARENT         1
#define OPAQUE              2
#define BKMODE_LAST         2

*--	/* Binary raster ops */
#define R2_BLACK            1   &&	/*  0       */
#define R2_NOTMERGEPEN      2   &&	/* DPon     */
#define R2_MASKNOTPEN       3   &&	/* DPna     */
#define R2_NOTCOPYPEN       4   &&	/* PN       */
#define R2_MASKPENNOT       5   &&	/* PDna     */
#define R2_NOT              6   &&	/* Dn       */
#define R2_XORPEN           7   &&	/* DPx      */
#define R2_NOTMASKPEN       8   &&	/* DPan     */
#define R2_MASKPEN          9   &&	/* DPa      */
#define R2_NOTXORPEN        10  &&	/* DPxn     */
#define R2_NOP              11  &&	/* D        */
#define R2_MERGENOTPEN      12  &&	/* DPno     */
#define R2_COPYPEN          13  &&	/* P        */
#define R2_MERGEPENNOT      14  &&	/* PDno     */
#define R2_MERGEPEN         15  &&	/* DPo      */
#define R2_WHITE            16  &&	/*  1       */
#define R2_LAST             16

*--	/* Ternary raster operations */
#define SRCCOPY             0x00CC0020 && /* dest = source                   */
#define SRCPAINT            0x00EE0086 && /* dest = source OR dest           */
#define SRCAND              0x008800C6 && /* dest = source AND dest          */
#define SRCINVERT           0x00660046 && /* dest = source XOR dest          */
#define SRCERASE            0x00440328 && /* dest = source AND (NOT dest )   */
#define NOTSRCCOPY          0x00330008 && /* dest = (NOT source)             */
#define NOTSRCERASE         0x001100A6 && /* dest = (NOT src) AND (NOT dest) */
#define MERGECOPY           0x00C000CA && /* dest = (source AND pattern)     */
#define MERGEPAINT          0x00BB0226 && /* dest = (NOT source) OR dest     */
#define PATCOPY             0x00F00021 && /* dest = pattern                  */
#define PATPAINT            0x00FB0A09 && /* dest = DPSnoo                   */
#define PATINVERT           0x005A0049 && /* dest = pattern XOR dest         */
#define DSTINVERT           0x00550009 && /* dest = (NOT dest)               */
#define BLACKNESS           0x00000042 && /* dest = BLACK                    */
#define WHITENESS           0x00FF0062 && /* dest = WHITE                    */


*//====== PROGRESS CONTROL =====================================================

#if UNICODE
#define PROGRESS_CLASS		(StrConv( "msctls_progress32", 5))
#else
#define PROGRESS_CLASS		"msctls_progress32"
#endif

#define PBS_SMOOTH		0x01
#define PBS_VERTICAL		0x04

#define PBM_SETRANGE		(WM_USER+1)
#define PBM_SETPOS		(WM_USER+2)
#define PBM_DELTAPOS		(WM_USER+3)
#define PBM_SETSTEP		(WM_USER+4)
#define PBM_STEPIT		(WM_USER+5)

#define PBM_SETRANGE32		(WM_USER+6)	&& // lParam = high, wParam = low
#define PBM_GETRANGE		(WM_USER+7)	&& // wParam = return (TRUE ? low : high). lParam = PPBRANGE or NULL
#define PBM_GETPOS		(WM_USER+8)

*--	#if (_WIN32_IE >= 0x0400)
#define PBM_SETBARCOLOR		(WM_USER+9)	&& // lParam = bar color
*--	#endif      // _WIN32_IE >= 0x0400
#define PBM_SETBKCOLOR		CCM_SETBKCOLOR	&& // lParam = bkColor

*//====== STATUS BAR CONTROL ===================================================

#define SBARS_SIZEGRIP          0x0100

#ifdef _WIN32
#define STATUSCLASSNAMEW		(StrConv( "msctls_statusbar32", 5))
#define STATUSCLASSNAMEA		"msctls_statusbar32"

#if UNICODE
#define STATUSCLASSNAME			STATUSCLASSNAMEW
#else
#define STATUSCLASSNAME			STATUSCLASSNAMEA
#endif

#else
#define STATUSCLASSNAME         "msctls_statusbar"
#endif

#define SB_SETTEXTA				(WM_USER+1)
#define SB_SETTEXTW				(WM_USER+11)
#define SB_GETTEXTA				(WM_USER+2)
#define SB_GETTEXTW				(WM_USER+13)
#define SB_GETTEXTLENGTHA		(WM_USER+3)
#define SB_GETTEXTLENGTHW		(WM_USER+12)
*!*	#if (_WIN32_IE >= 0x0400)
#define SB_SETICON              (WM_USER+15)
#define SB_SETTIPTEXTA          (WM_USER+16)
#define SB_SETTIPTEXTW          (WM_USER+17)
#define SB_GETTIPTEXTA          (WM_USER+18)
#define SB_GETTIPTEXTW          (WM_USER+19)
#define SB_GETICON              (WM_USER+20)
*!*	#endif

#if	UNICODE
#define SB_GETTEXT				SB_GETTEXTW
#define SB_SETTEXT				SB_SETTEXTW
#define SB_GETTEXTLENGTH		SB_GETTEXTLENGTHW
*!*	#if (_WIN32_IE >= 0x0400)
#define SB_SETTIPTEXT           SB_SETTIPTEXTW
#define SB_GETTIPTEXT           SB_GETTIPTEXTW
*!*	#endif
#else
#define SB_GETTEXT				SB_GETTEXTA
#define SB_SETTEXT				SB_SETTEXTA
#define SB_GETTEXTLENGTH		SB_GETTEXTLENGTHA
*!*	#if (_WIN32_IE >= 0x0400)
#define SB_SETTIPTEXT           SB_SETTIPTEXTA
#define SB_GETTIPTEXT           SB_GETTIPTEXTA
*!*	#endif
#endif

#define SB_SETPARTS				(WM_USER+4)
#define SB_GETPARTS				(WM_USER+6)
#define SB_GETBORDERS			(WM_USER+7)
#define SB_SETMINHEIGHT			(WM_USER+8)
#define SB_SIMPLE				(WM_USER+9)
#define SB_GETRECT				(WM_USER+10)
*!*	#if (_WIN32_IE >= 0x0300)
*!*	#define SB_ISSIMPLE             (WM_USER+14)
*!*	#endif
*!*	#if (_WIN32_IE >= 0x0400)
*!*	#define SB_SETICON              (WM_USER+15)
*!*	#define SB_SETTIPTEXTA          (WM_USER+16)
*!*	#define SB_SETTIPTEXTW          (WM_USER+17)
*!*	#define SB_GETTIPTEXTA          (WM_USER+18)
*!*	#define SB_GETTIPTEXTW          (WM_USER+19)
*!*	#define SB_GETICON              (WM_USER+20)
*!*	#define SB_SETUNICODEFORMAT     CCM_SETUNICODEFORMAT
*!*	#define SB_GETUNICODEFORMAT     CCM_GETUNICODEFORMAT
*!*	#endif

#define SBT_OWNERDRAW			0x1000
#define SBT_NOBORDERS			0x0100
#define SBT_POPOUT				0x0200
#define SBT_RTLREADING			0x0400
*!*	#if (_WIN32_IE >= 0x0400)
#define SBT_TOOLTIPS             0x0800
*!*	#endif

*!*	#define SB_SETBKCOLOR			CCM_SETBKCOLOR      &&	// lParam = bkColor

*--     //====== TRACKBAR CONTROL =====================================================
*--
*--     #ifndef NOTRACKBAR
*--
*--     #ifdef _WIN32
*--
#define TRACKBAR_CLASSA		"msctls_trackbar32"
#define TRACKBAR_CLASSW		(StrConv( "msctls_trackbar32", 5))

#if	UNICODE
#define  TRACKBAR_CLASS         TRACKBAR_CLASSW
#else
#define  TRACKBAR_CLASS         TRACKBAR_CLASSA
#endif
*--
*--     #else
*--     #define TRACKBAR_CLASS          "msctls_trackbar"
*--     #endif
*--
*--
#define TBS_AUTOTICKS           0x0001
#define TBS_VERT                0x0002
#define TBS_HORZ                0x0000
#define TBS_TOP                 0x0004
#define TBS_BOTTOM              0x0000
#define TBS_LEFT                0x0004
#define TBS_RIGHT               0x0000
#define TBS_BOTH                0x0008
#define TBS_NOTICKS             0x0010
#define TBS_ENABLESELRANGE      0x0020
#define TBS_FIXEDLENGTH         0x0040
#define TBS_NOTHUMB             0x0080
#define TBS_TOOLTIPS            0x0100
*--	#if (_WIN32_IE >= 0x0500)
#define TBS_REVERSED            0x0200  &&	// Accessibility hint: the smaller number (usually the min value) means "high" and the larger number (usually the max value) means "low"
*--	#endif

#define TBM_GETPOS              (WM_USER)
#define TBM_GETRANGEMIN         (WM_USER+1)
#define TBM_GETRANGEMAX         (WM_USER+2)
#define TBM_GETTIC              (WM_USER+3)
#define TBM_SETTIC              (WM_USER+4)
#define TBM_SETPOS              (WM_USER+5)
#define TBM_SETRANGE            (WM_USER+6)
#define TBM_SETRANGEMIN         (WM_USER+7)
#define TBM_SETRANGEMAX         (WM_USER+8)
#define TBM_CLEARTICS           (WM_USER+9)
#define TBM_SETSEL              (WM_USER+10)
#define TBM_SETSELSTART         (WM_USER+11)
#define TBM_SETSELEND           (WM_USER+12)
#define TBM_GETPTICS            (WM_USER+14)
#define TBM_GETTICPOS           (WM_USER+15)
#define TBM_GETNUMTICS          (WM_USER+16)
#define TBM_GETSELSTART         (WM_USER+17)
#define TBM_GETSELEND           (WM_USER+18)
#define TBM_CLEARSEL            (WM_USER+19)
#define TBM_SETTICFREQ          (WM_USER+20)
#define TBM_SETPAGESIZE         (WM_USER+21)
#define TBM_GETPAGESIZE         (WM_USER+22)
#define TBM_SETLINESIZE         (WM_USER+23)
#define TBM_GETLINESIZE         (WM_USER+24)
#define TBM_GETTHUMBRECT        (WM_USER+25)
#define TBM_GETCHANNELRECT      (WM_USER+26)
#define TBM_SETTHUMBLENGTH      (WM_USER+27)
#define TBM_GETTHUMBLENGTH      (WM_USER+28)
#define TBM_SETTOOLTIPS         (WM_USER+29)
#define TBM_GETTOOLTIPS         (WM_USER+30)
#define TBM_SETTIPSIDE          (WM_USER+31)
*--     // TrackBar Tip Side flags
#define TBTS_TOP                0
#define TBTS_LEFT               1
#define TBTS_BOTTOM             2
#define TBTS_RIGHT              3
*--
#define TBM_SETBUDDY            (WM_USER+32) &&	// wparam = BOOL fLeft; (or right)
#define TBM_GETBUDDY            (WM_USER+33) &&	// wparam = BOOL fLeft; (or right)
*--

#define TB_LINEUP               0
#define TB_LINEDOWN             1
#define TB_PAGEUP               2
#define TB_PAGEDOWN             3
#define TB_THUMBPOSITION        4
#define TB_THUMBTRACK           5
#define TB_TOP                  6
#define TB_BOTTOM               7
#define TB_ENDTRACK             8

*--
*--     // custom draw item specs
*--     #define TBCD_TICS    0x0001
*--     #define TBCD_THUMB   0x0002
*--     #define TBCD_CHANNEL 0x0003
*--
*--     #endif // trackbar

*!*	/*
*!*	* Window Styles
*!*	*/

#define WS_OVERLAPPED       0x00000000
#define WS_POPUP            0x80000000
#define WS_CHILD            0x40000000
#define WS_MINIMIZE         0x20000000
#define WS_VISIBLE          0x10000000
#define WS_DISABLED         0x08000000
#define WS_CLIPSIBLINGS     0x04000000
#define WS_CLIPCHILDREN     0x02000000
#define WS_MAXIMIZE         0x01000000
#define WS_CAPTION          0x00C00000
#define WS_BORDER           0x00800000
#define WS_DLGFRAME         0x00400000
#define WS_VSCROLL          0x00200000
#define WS_HSCROLL          0x00100000
#define WS_SYSMENU          0x00080000
#define WS_THICKFRAME       0x00040000
#define WS_GROUP            0x00020000
#define WS_TABSTOP          0x00010000

*--	/*
*--	 * Extended Window Styles
*--	 */
#define WS_EX_DLGMODALFRAME     0x00000001
#define WS_EX_NOPARENTNOTIFY    0x00000004
#define WS_EX_TOPMOST           0x00000008
#define WS_EX_ACCEPTFILES       0x00000010
#define WS_EX_TRANSPARENT       0x00000020
*--	#if(WINVER >= 0x0400)
#define WS_EX_MDICHILD          0x00000040
#define WS_EX_TOOLWINDOW        0x00000080
#define WS_EX_WINDOWEDGE        0x00000100
#define WS_EX_CLIENTEDGE        0x00000200
#define WS_EX_CONTEXTHELP       0x00000400

#define WS_EX_RIGHT             0x00001000
#define WS_EX_LEFT              0x00000000
#define WS_EX_RTLREADING        0x00002000
#define WS_EX_LTRREADING        0x00000000
#define WS_EX_LEFTSCROLLBAR     0x00004000
#define WS_EX_RIGHTSCROLLBAR    0x00000000

#define WS_EX_CONTROLPARENT     0x00010000
#define WS_EX_STATICEDGE        0x00020000
#define WS_EX_APPWINDOW         0x00040000


*--	#define WS_EX_OVERLAPPEDWINDOW  (WS_EX_WINDOWEDGE | WS_EX_CLIENTEDGE)
*--	#define WS_EX_PALETTEWINDOW     (WS_EX_WINDOWEDGE | WS_EX_TOOLWINDOW | WS_EX_TOPMOST)

*!*	/*
*!*	 * Window Messages
*!*	 */

#define WM_NULL				0x0000
#define WM_CREATE			0x0001
#define WM_DESTROY			0x0002
#define WM_MOVE				0x0003
#define WM_SIZE				0x0005

#define WM_ACTIVATE			0x0006

*/****** Window repainting ***************************************************/

#define WM_PAINT            0x000F
#define WM_ERASEBKGND       0x0014
#define WM_ICONERASEBKGND   0x0027

#define WM_SETFOCUS                     0x0007
#define WM_KILLFOCUS                    0x0008
#define WM_ENABLE                       0x000A
#define WM_SETREDRAW                    0x000B
#define WM_SETTEXT                      0x000C
#define WM_GETTEXT                      0x000D
#define WM_GETTEXTLENGTH                0x000E
#define WM_PAINT                        0x000F
#define WM_CLOSE                        0x0010
#define WM_QUERYENDSESSION              0x0011
#define WM_QUIT                         0x0012
#define WM_QUERYOPEN                    0x0013
#define WM_ERASEBKGND                   0x0014
#define WM_SYSCOLORCHANGE               0x0015
#define WM_ENDSESSION                   0x0016
#define WM_SHOWWINDOW                   0x0018
#define WM_WININICHANGE                 0x001A
*--	#if(WINVER >= 0x0400)
#define WM_SETTINGCHANGE                WM_WININICHANGE
*--	#endif /* WINVER >= 0x0400 */


#define WM_DEVMODECHANGE                0x001B
#define WM_ACTIVATEAPP                  0x001C
#define WM_FONTCHANGE                   0x001D
#define WM_TIMECHANGE                   0x001E
#define WM_CANCELMODE                   0x001F
#define WM_SETCURSOR                    0x0020
#define WM_MOUSEACTIVATE                0x0021
#define WM_CHILDACTIVATE                0x0022
#define WM_QUEUESYNC                    0x0023

#define WM_GETMINMAXINFO                0x0024

#define WM_PAINTICON                    0x0026
#define WM_ICONERASEBKGND               0x0027
#define WM_NEXTDLGCTL                   0x0028
#define WM_SPOOLERSTATUS                0x002A
#define WM_DRAWITEM                     0x002B
#define WM_MEASUREITEM                  0x002C
#define WM_DELETEITEM                   0x002D
#define WM_VKEYTOITEM                   0x002E
#define WM_CHARTOITEM                   0x002F
#define WM_SETFONT                      0x0030
#define WM_GETFONT                      0x0031

*!*	/*
*!*	* ShowWindow() Commands
*!*	*/

#define SW_HIDE             0
#define SW_SHOWNORMAL       1
#define SW_NORMAL           1
#define SW_SHOWMINIMIZED    2
#define SW_SHOWMAXIMIZED    3
#define SW_MAXIMIZE         3
#define SW_SHOWNOACTIVATE   4
#define SW_SHOW             5
#define SW_MINIMIZE         6
#define SW_SHOWMINNOACTIVE  7
#define SW_SHOWNA           8
#define SW_RESTORE          9
#define SW_SHOWDEFAULT      10
#define SW_MAX              10

*//====== ANIMATE CONTROL ======================================================

#define ANIMATE_CLASS		"SysAnimate32"

*!*	// begin_r_commctrl

#define ACS_CENTER			0x0001
#define ACS_TRANSPARENT		0x0002
#define ACS_AUTOPLAY		0x0004

*!*	#if (_WIN32_IE >= 0x0300)
*!*	#define ACS_TIMER               0x0008  // don't use threads... use timers
*!*	#endif

*!*	// end_r_commctrl

#define ACM_OPENA			(WM_USER+100)

#define ACM_OPENW			(WM_USER+103)

#if	UNICODE
#define ACM_OPEN			ACM_OPENW
#else
#define ACM_OPEN			ACM_OPENA
#endif

#define ACM_PLAY			(WM_USER+101)
#define ACM_STOP			(WM_USER+102)

#define ACN_START			1
#define ACN_STOP			2

#define	AC_SYS_SEARCH		150
#define	AC_SYS_FINDFILE		151
#define	AC_SYS_FINDCOMP		152
#define	AC_SYS_FILEMOVE		160
#define	AC_SYS_FILECOPY		161
#define	AC_SYS_FILEDEL		162
#define	AC_SYS_FILENUKE		163
#define	AC_SYS_FILEDELR		164


*//=============================================================================

*--/*
*-- * Scroll Bar Constants
*-- */
#define SB_HORZ             0
#define SB_VERT             1
#define SB_CTL              2
#define SB_BOTH             3

*--/*
*-- * Scroll Bar Commands
*-- */
#define SB_LINEUP           0
#define SB_LINELEFT         0
#define SB_LINEDOWN         1
#define SB_LINERIGHT        1
#define SB_PAGEUP           2
#define SB_PAGELEFT         2
#define SB_PAGEDOWN         3
#define SB_PAGERIGHT        3
#define SB_THUMBPOSITION    4
#define SB_THUMBTRACK       5
#define SB_TOP              6
#define SB_LEFT             6
#define SB_BOTTOM           7
#define SB_RIGHT            7
#define SB_ENDSCROLL        8

*--//----------------------------------------------------------------------------
**/*
*** Static Control Constants
**/
#define SS_LEFT             0x00000000
#define SS_CENTER           0x00000001
#define SS_RIGHT            0x00000002
#define SS_ICON             0x00000003
#define SS_BLACKRECT        0x00000004
#define SS_GRAYRECT         0x00000005
#define SS_WHITERECT        0x00000006
#define SS_BLACKFRAME       0x00000007
#define SS_GRAYFRAME        0x00000008
#define SS_WHITEFRAME       0x00000009
#define SS_USERITEM         0x0000000A
#define SS_SIMPLE           0x0000000B
#define SS_LEFTNOWORDWRAP   0x0000000C
*--	#if(WINVER >= 0x0400)
#define SS_OWNERDRAW        0x0000000D
#define SS_BITMAP           0x0000000E
#define SS_ENHMETAFILE      0x0000000F
#define SS_ETCHEDHORZ       0x00000010
#define SS_ETCHEDVERT       0x00000011
#define SS_ETCHEDFRAME      0x00000012
#define SS_TYPEMASK         0x0000001F
*--	#endif /* WINVER >= 0x0400 */
#define SS_NOPREFIX         0x00000080	&& /* Don't do "&" character translation */
*--	#if(WINVER >= 0x0400)
#define SS_NOTIFY           0x00000100
#define SS_CENTERIMAGE      0x00000200
#define SS_RIGHTJUST        0x00000400
#define SS_REALSIZEIMAGE    0x00000800
#define SS_SUNKEN           0x00001000
#define SS_ENDELLIPSIS      0x00004000
#define SS_PATHELLIPSIS     0x00008000
#define SS_WORDELLIPSIS     0x0000C000
#define SS_ELLIPSISMASK     0x0000C000
*--	#endif /* WINVER >= 0x0400 */ 

#define	STM_SETIMAGE	0x0172

#define IMAGE_BITMAP	0
#define IMAGE_ICON		1
#define IMAGE_CURSOR	2

*--	//====== MONTHCAL CONTROL ======================================================

*--	#ifndef NOMONTHCAL
*--	#ifdef _WIN32

*--	#define MONTHCAL_CLASSW          L"SysMonthCal32"
#define MONTHCAL_CLASSA		"SysMonthCal32"

*--	#ifdef UNICODE
*--	#define MONTHCAL_CLASS	MONTHCAL_CLASSW
*--	#else
#define MONTHCAL_CLASS		MONTHCAL_CLASSA
*--	#endif

#define MCM_FIRST		0x1000

#define MCM_GETCURSEL		(MCM_FIRST + 1)
#define MCM_SETCURSEL		(MCM_FIRST + 2)

#define MCM_GETMINREQRECT	(MCM_FIRST + 9)

*--// set colors to draw control with -- see MCSC_ bits below
#define MCM_SETCOLOR		(MCM_FIRST + 10)
#define MCM_GETCOLOR		(MCM_FIRST + 11)

#define MCSC_BACKGROUND   0   // the background color (between months)
#define MCSC_TEXT         1   // the dates
#define MCSC_TITLEBK      2   // background of the title
#define MCSC_TITLETEXT    3
#define MCSC_MONTHBK      4   // background within the month cal
#define MCSC_TRAILINGTEXT 5   // the text color of header & trailing days

#define MCS_DAYSTATE        0x0001
#define MCS_MULTISELECT     0x0002
#define MCS_WEEKNUMBERS     0x0004
*--	#if (_WIN32_IE >= 0x0400)
#define MCS_NOTODAYCIRCLE   0x0008
#define MCS_NOTODAY         0x0010
*--	#else
*--	#define MCS_NOTODAY         0x0008
*--	#endif


#define MCM_SETTODAY		(MCM_FIRST + 12)
#define MCM_GETTODAY		(MCM_FIRST + 13)

#define MCM_SETFIRSTDAYOFWEEK	(MCM_FIRST + 15)
#define MCM_GETFIRSTDAYOFWEEK	(MCM_FIRST + 16)

#define MCM_SETUNICODEFORMAT     CCM_SETUNICODEFORMAT
#define MCM_GETUNICODEFORMAT     CCM_GETUNICODEFORMAT


*--	//====== DATETIMEPICK CONTROL ==================================================

*--	#ifndef NODATETIMEPICK
*--	#ifdef _WIN32

*--	#define DATETIMEPICK_CLASSW          L"SysDateTimePick32"
#define DATETIMEPICK_CLASSA          "SysDateTimePick32"

*--	#ifdef UNICODE
*--	#define DATETIMEPICK_CLASS           DATETIMEPICK_CLASSW
*--	#else
#define DATETIMEPICK_CLASS           DATETIMEPICK_CLASSA
*--	#endif

#define DTM_FIRST		0x1000

#define DTM_GETSYSTEMTIME	(DTM_FIRST + 1)
#define DTM_SETSYSTEMTIME	(DTM_FIRST + 2)
#define DTM_GETRANGE		(DTM_FIRST + 3)
#define DTM_SETRANGE		(DTM_FIRST + 4)
#define DTM_SETFORMATA		(DTM_FIRST + 5)
#define DTM_SETFORMATW		(DTM_FIRST + 50)

*--	#ifdef UNICODE
*--	#define DTM_SETFORMAT       DTM_SETFORMATW
*--	#else
#define DTM_SETFORMAT		DTM_SETFORMATA
*--	#endif

#define DTM_SETMCCOLOR    (DTM_FIRST + 6)

#define DTM_GETMCCOLOR    (DTM_FIRST + 7)

#define DTM_GETMONTHCAL   (DTM_FIRST + 8)

*--	#if (_WIN32_IE >= 0x0400)

#define DTM_SETMCFONT     (DTM_FIRST + 9)

#define DTM_GETMCFONT     (DTM_FIRST + 10)

*--	#endif      // _WIN32_IE >= 0x0400

#define DTS_UPDOWN          0x0001 && // use UPDOWN instead of MONTHCAL
#define DTS_SHOWNONE        0x0002 && // allow a NONE selection
#define DTS_SHORTDATEFORMAT 0x0000 && // use the short date format (app must forward WM_WININICHANGE messages)
#define DTS_LONGDATEFORMAT  0x0004 && // use the long date format (app must forward WM_WININICHANGE messages)
*--	#if (_WIN32_IE >= 0x500)
#define DTS_SHORTDATECENTURYFORMAT 0x000C	&&// short date format with century (app must forward WM_WININICHANGE messages)
*--	#endif // (_WIN32_IE >= 0x500)
#define DTS_TIMEFORMAT      0x0009 && // use the time format (app must forward WM_WININICHANGE messages)
#define DTS_APPCANPARSE     0x0010 && // allow user entered strings (app MUST respond to DTN_USERSTRING)
#define DTS_RIGHTALIGN      0x0020 && // right-align popup instead of left-align it


#define GDTR_MIN     0x0001
#define GDTR_MAX     0x0002

#define GDT_ERROR    -1
#define GDT_VALID    0
#define GDT_NONE     1




*//---------------------------------------------------------------------------------------
*//---------------------------------------------------------------------------------------
*///  ====================== Pager Control =============================
*//---------------------------------------------------------------------------------------
*//---------------------------------------------------------------------------------------


*//Pager Class Name
#define WC_PAGESCROLLERW           (StrConv( "SysPager", 5))
#define WC_PAGESCROLLERA           "SysPager"

#if UNICODE
#define WC_PAGESCROLLER          WC_PAGESCROLLERW
#else
#define WC_PAGESCROLLER          WC_PAGESCROLLERA
#endif


*//---------------------------------------------------------------------------------------
*// Pager Control Styles
*//---------------------------------------------------------------------------------------
#define PGS_VERT                0x00000000
#define PGS_HORZ                0x00000001
#define PGS_AUTOSCROLL          0x00000002
#define PGS_DRAGNDROP           0x00000004

*//---------------------------------------------------------------------------------------
*// Pager Button State
*//---------------------------------------------------------------------------------------
*//The scroll can be in one of the following control State 
#define  PGF_INVISIBLE   0      &&	// Scroll button is not visible
#define  PGF_NORMAL      1      &&	// Scroll button is in normal state
#define  PGF_GRAYED      2      &&	// Scroll button is in grayed state
#define  PGF_DEPRESSED   4      &&	// Scroll button is in depressed state
#define  PGF_HOT         8      &&	// Scroll button is in hot state


*// The following identifiers specifies the button control 
#define PGB_TOPORLEFT       0
#define PGB_BOTTOMORRIGHT   1

*//---------------------------------------------------------------------------------------
*// Pager Control  Messages
*//---------------------------------------------------------------------------------------
#define PGM_SETCHILD            (PGM_FIRST + 1)  &&	// lParam == hwnd
*--	#define Pager_SetChild(hwnd, hwndChild) \
*--	        (void)SNDMSG((hwnd), PGM_SETCHILD, 0, (LPARAM)(hwndChild))

#define PGM_RECALCSIZE          (PGM_FIRST + 2)
*--	#define Pager_RecalcSize(hwnd) \
*--	        (void)SNDMSG((hwnd), PGM_RECALCSIZE, 0, 0)

#define PGM_FORWARDMOUSE        (PGM_FIRST + 3)
*--	#define Pager_ForwardMouse(hwnd, bForward) \
*--	        (void)SNDMSG((hwnd), PGM_FORWARDMOUSE, (WPARAM)(bForward), 0)

#define PGM_SETBKCOLOR          (PGM_FIRST + 4)
*--	#define Pager_SetBkColor(hwnd, clr) \
*--	        (COLORREF)SNDMSG((hwnd), PGM_SETBKCOLOR, 0, (LPARAM)clr)

#define PGM_GETBKCOLOR          (PGM_FIRST + 5)
*--	#define Pager_GetBkColor(hwnd) \
*--	        (COLORREF)SNDMSG((hwnd), PGM_GETBKCOLOR, 0, 0)

#define PGM_SETBORDER          (PGM_FIRST + 6)
*--	#define Pager_SetBorder(hwnd, iBorder) \
*--	        (int)SNDMSG((hwnd), PGM_SETBORDER, 0, (LPARAM)iBorder)

#define PGM_GETBORDER          (PGM_FIRST + 7)
*--	#define Pager_GetBorder(hwnd) \
*--	        (int)SNDMSG((hwnd), PGM_GETBORDER, 0, 0)

#define PGM_SETPOS              (PGM_FIRST + 8)
*--	#define Pager_SetPos(hwnd, iPos) \
*--	        (int)SNDMSG((hwnd), PGM_SETPOS, 0, (LPARAM)iPos)

#define PGM_GETPOS              (PGM_FIRST + 9)
*--	#define Pager_GetPos(hwnd) \
*--	        (int)SNDMSG((hwnd), PGM_GETPOS, 0, 0)

#define PGM_SETBUTTONSIZE       (PGM_FIRST + 10)
*--	#define Pager_SetButtonSize(hwnd, iSize) \
*--	        (int)SNDMSG((hwnd), PGM_SETBUTTONSIZE, 0, (LPARAM)iSize)

#define PGM_GETBUTTONSIZE       (PGM_FIRST + 11)
*--	#define Pager_GetButtonSize(hwnd) \
*--	        (int)SNDMSG((hwnd), PGM_GETBUTTONSIZE, 0,0)

#define PGM_GETBUTTONSTATE      (PGM_FIRST + 12)
*--	#define Pager_GetButtonState(hwnd, iButton) \
*--	        (DWORD)SNDMSG((hwnd), PGM_GETBUTTONSTATE, 0, (LPARAM)iButton)

#define PGM_GETDROPTARGET       CCM_GETDROPTARGET
*--	#define Pager_GetDropTarget(hwnd, ppdt) \
*--	        (void)SNDMSG((hwnd), PGM_GETDROPTARGET, 0, (LPARAM)ppdt)


#define OF_READ			0x00000000
#define OF_WRITE		0x00000001
#define OF_READWRITE		0x00000002
#define OF_SHARE_COMPAT		0x00000000
#define OF_SHARE_EXCLUSIVE	0x00000010
#define OF_SHARE_DENY_WRITE	0x00000020
#define OF_SHARE_DENY_READ	0x00000030
#define OF_SHARE_DENY_NONE	0x00000040
#define OF_PARSE		0x00000100
#define OF_DELETE		0x00000200
#define OF_VERIFY		0x00000400
#define OF_CANCEL		0x00000800
#define OF_CREATE		0x00001000
#define OF_PROMPT		0x00002000
#define OF_EXIST		0x00004000
#define OF_REOPEN		0x00008000

#define OFS_MAXPATHNAME		128

#define _OFSTRUCT		(Chr(136)+Repl(Chr(0),136))

*--	
*--	typedef struct _OFSTRUCT {
*--	    BYTE cBytes;
*--	    BYTE fFixedDisk;
*--	    WORD nErrCode;
*--	    WORD Reserved1;
*--	    WORD Reserved2;
*--	    CHAR szPathName[OFS_MAXPATHNAME];
*--	} OFSTRUCT, *LPOFSTRUCT, *POFSTRUCT;
*--	


*--//----------------------------------------------------------------------------
*--//
*--//   ObjToClient constants
*--//
*--//----------------------------------------------------------------------------

#define OTC_TOP				1
#define OTC_LEFT			2
#define OTC_WIDTH			3
#define OTC_HEIGHT			4

#endif  &&      //      __COMMON_CONTROLS_H
